osl::rating::PatternLong2 Class Reference

`#include <pattern.h>`

Inheritance diagram for osl::rating::PatternLong2:

## Public Member Functions

| PatternLong2 (Direction d, Ptype s, LongTarget2 t2)
bool | match (const NumEffectState &state, Move move, const RatingEnv &) const
Public Member Functions inherited from osl::rating::Feature
| Feature (const std::string &name)
virtual | ~Feature ()
virtual bool | effectiveInCheck () const
const std::string & | name () const

## Static Public Member Functions

static const Piece | find (const NumEffectState &state, Move move, Direction direction)

## Static Private Member Functions

static const std::string | name (Direction d, Ptype self)

## Private Attributes

Direction | direction
Ptype | self
LongTarget2 | target2

## Detailed Description

Definition at line 149 of file pattern.h.

## Constructor & Destructor Documentation

## PatternLong2()

osl::rating::PatternLong2::PatternLong2 | ( | Direction | d,
|  | Ptype | s,
|  | LongTarget2 | t2 )

Definition at line 82 of file pattern.cc.

References osl::BISHOP, direction, osl::rating::Feature::Feature(), osl::LANCE, name(), osl::ROOK, self, target2, and osl::unpromote().

## Member Function Documentation

## find()

const Piece osl::rating::PatternLong2::find | ( | const NumEffectState & | state,
|  | Move | move,
|  | Direction | direction )

inline static

Definition at line 157 of file pattern.h.

References osl::Board_Table, direction, osl::Move::from(), osl::Piece::isPiece(), osl::SimpleState::nextPiece(), osl::Move::player(), osl::Piece::square(), and osl::Move::to().

Referenced by osl::rating::PatternLongGroup2::findMatch(), and match().

## match()

bool osl::rating::PatternLong2::match | ( | const NumEffectState & | state,
|  | Move | move,
|  | const RatingEnv & | ) const

inline virtual

Implements osl::rating::Feature.

Definition at line 164 of file pattern.h.

References direction, find(), osl::Move::ptype(), self, and target2.

## name()

const std::string osl::rating::PatternLong2::name | ( | Direction | d,
|  | Ptype | self )

static private

Definition at line 89 of file pattern.cc.

References osl::Ptype_Table, and self.

Referenced by PatternLong2().

## Member Data Documentation

## direction

Direction osl::rating::PatternLong2::direction

private

Definition at line 151 of file pattern.h.

Referenced by find(), match(), and PatternLong2().

## self

Ptype osl::rating::PatternLong2::self

private

Definition at line 152 of file pattern.h.

Referenced by match(), name(), and PatternLong2().

## target2

LongTarget2 osl::rating::PatternLong2::target2

private

Definition at line 153 of file pattern.h.

Referenced by match(), and PatternLong2().

The documentation for this class was generated from the following files:

- pattern.h
- pattern.cc